#!/usr/bin/perl
# change3.cgi
# Change a post, including colateral data

use warnings ;
use strict ;
use DB_File ;

require "session.pl";

## DECLARATIONS
our $dbdir;
require "../conf.pl"; #get $dbdir value from ../conf.pl
$dbdir = "../".$dbdir; #fix $dbdir

my $cnt=0 ; # wild-card counter
my @list;
my $id ;
my $cadena ;
my $br = "<br/>";


## OPENING DATABASES

sub Compare { my ($key1,$key2)=@_; "\L$key2" cmp "\L$key1"; } # getting first the last post
$DB_BTREE->{'compare'} = \&Compare ; # specify the Perl sub that will do the comparison

my %titles ; # to handle titles DB
tie %titles, "DB_File", $dbdir."habla_titles.db", O_RDWR|O_CREAT, 0666, $DB_BTREE # opendb, if it does not exist create
	or die "Cannot open file 'titles': $!\n" ; # error :(
my %texts ; # to handle texts DB
tie %texts, "DB_File", $dbdir."habla_texts.db", O_RDWR|O_CREAT, 0666, $DB_BTREE # opendb, if it does not exist create
	or die "Cannot open file 'texts': $!\n" ; # error :(

$DB_BTREE->{'flags'} = R_DUP ; # permit duplication in next DB's
my ($id_tag, %id_tag); # to handle id -> tag DB
$id_tag = tie %id_tag, "DB_File", $dbdir."habla_id_tag.db", O_RDWR|O_CREAT, 0666, $DB_BTREE # opendb, if it does not exist create
	or die "Cannot open file id_tag: $!\n" ; # error :(
my ($tag_id, %tag_id); # to handle tag -> id DB
$tag_id = tie %tag_id, "DB_File", $dbdir."habla_tag_id.db", O_RDWR|O_CREAT, 0666, $DB_BTREE # opendb, if it does not exist create
	or die "Cannot open file tag_id: $!\n" ; # error :(


my $buffer;
my ($name, $value);

read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'}); # read POST information
#$buffer=$ENV{'QUERY_STRING'}; # read GET information
my @pairs = split(/&/, $buffer); # separating variables
($name, $value) = split(/=/, $pairs[0]);
if($name eq "id") {$id=$value;} else {print "Content-type: text/html; charset=utf-8\n\n<html><body><p>Error0, with input data: ".$ENV{'QUERY_STRING'}."</p></body></html>"; exit 0;}


### CREATING HTML # http server head
print "Content-type: text/html; charset=utf-8\n\n
<html><head><title>Habla_</title>
<meta http-equiv=\"Refresh\" content=\"2; URL=change2.cgi?id=$id\">
</head><body>";


# Delete in habla_tag_id.db and habla_tag_id
@list = $id_tag->get_dup($id); # get a list of tags
foreach (@list){
	$cadena = $_;
	if($tag_id->del_dup($_,$id)==0) {print "<p>Borrada etiqueta $cadena a id</p>\n" ;}
	if($id_tag->del_dup($id,$_)==0) {print "<p>Borrada id a etiqueta $cadena</p>\n" ;}
} # delete each {tag,id}

# Introducing data on DBs
foreach my $pair (@pairs) {
	($name, $value) = split(/=/, $pair); # separating name and value
	$name =~ tr/+/ /;
	$name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	$value =~ tr/+/ /;
	$value =~ s/%0D%0A/$br/g;
	$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;

#	if( length($value) < 3 ){print "<br/>Error. Every fields has to have 2 characters at least."; exit 0;}
	if ($name eq "title")		{ $titles{$id} = $value ;}
	elsif($name eq "text")	{ $texts{$id} = $value ;}
	elsif($name eq "tag")		{ $tag_id{$value} = $id ; $id_tag{$id} = $value ; }
	elsif($name eq "ctag")	{ if($value eq "uno"){$cnt = 1;} }
	elsif($name eq "ttag")	{ if($cnt==1){$value =~ tr/ //; $tag_id{$value} = $id ; $id_tag{$id} = $value ; } }
	elsif($name eq "id")		{ print "Post ID : $value<br/>\n";}
#	else { print "<br/>Unknow variable name."; exit 0;}

	print "<p>$name --> $value</p>\n";
}


### CLOSING DATABASES

untie %titles ; #closing db's
untie %texts ;
undef $id_tag ; untie %id_tag ;
undef $tag_id ; untie %tag_id ;

print "Post $id modified</body></html>\n";

1; # Correct finish with 1